# icotest-voice
IcoTest Voice API

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.42
- Package version: 1.0.42
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import icotest_voice
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import icotest_voice
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import icotest_voice
from icotest_voice.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://localhost/icotest_voice
# See configuration.py for a list of all supported configuration parameters.
configuration = icotest_voice.Configuration(
    host = "https://localhost/icotest_voice"
)



# Enter a context with an instance of the API client
with icotest_voice.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = icotest_voice.ControllersApi(api_client)
    controller_id = 'ac331ccb-5841-44ec-9d32-4f4fe0c3c16c' # str | the unique id of the controller

    try:
        # DELETE Controller
        api_instance.delete_controller(controller_id)
    except ApiException as e:
        print("Exception when calling ControllersApi->delete_controller: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://localhost/icotest_voice*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ControllersApi* | [**delete_controller**](docs/ControllersApi.md#delete_controller) | **DELETE** /controllers | DELETE Controller
*ControllersApi* | [**get_controllers**](docs/ControllersApi.md#get_controllers) | **GET** /controllers | GET controllers
*ControllersApi* | [**post_controller_heartbeat**](docs/ControllersApi.md#post_controller_heartbeat) | **POST** /controllers/{controller_id}/heartbeat | POST Controller heartbeat
*ControllersApi* | [**put_controller**](docs/ControllersApi.md#put_controller) | **PUT** /controllers | PUT controller
*DevicesApi* | [**delete_device**](docs/DevicesApi.md#delete_device) | **DELETE** /devices | DELETE Device
*DevicesApi* | [**get_device_status**](docs/DevicesApi.md#get_device_status) | **GET** /devices/{device_id}/status | GET device status
*DevicesApi* | [**get_devices**](docs/DevicesApi.md#get_devices) | **GET** /devices | GET devices
*DevicesApi* | [**get_host_config**](docs/DevicesApi.md#get_host_config) | **GET** /host/config | Your GET endpoint
*DevicesApi* | [**post_device_appium_take_screenshot**](docs/DevicesApi.md#post_device_appium_take_screenshot) | **POST** /devices/{device_id}/APPIUM_take_screenshot | POST APPIUM take screenshot
*DevicesApi* | [**post_device_dect_get_handset_name**](docs/DevicesApi.md#post_device_dect_get_handset_name) | **POST** /devices/{device_id}/DECT_get_handset_name | POST DECT Get Handset Name
*DevicesApi* | [**post_device_dect_run_at_cmd**](docs/DevicesApi.md#post_device_dect_run_at_cmd) | **POST** /devices/{device_id}/DECT_run_AT_command | POST DECT Run AT Command
*DevicesApi* | [**post_device_deregister**](docs/DevicesApi.md#post_device_deregister) | **POST** /devices/{device_id}/deregister | POST deregister device
*DevicesApi* | [**post_device_end_call**](docs/DevicesApi.md#post_device_end_call) | **POST** /devices/{device_id}/end_call | POST end call
*DevicesApi* | [**post_device_heartbeat**](docs/DevicesApi.md#post_device_heartbeat) | **POST** /devices/{device_id}/heartbeat | POST Device heartbeat
*DevicesApi* | [**post_device_make_call**](docs/DevicesApi.md#post_device_make_call) | **POST** /devices/{device_id}/make_call | POST make call
*DevicesApi* | [**post_device_receive_call**](docs/DevicesApi.md#post_device_receive_call) | **POST** /devices/{device_id}/receive_call | POST receive call
*DevicesApi* | [**post_device_register**](docs/DevicesApi.md#post_device_register) | **POST** /devices/{device_id}/register | POST register device
*DevicesApi* | [**post_device_send_command**](docs/DevicesApi.md#post_device_send_command) | **POST** /devices/{device_id}/send_command | POST send command
*DevicesApi* | [**post_devices_scan**](docs/DevicesApi.md#post_devices_scan) | **POST** /devices/{controller_id}/scan | POST device scan
*DevicesApi* | [**put_device**](docs/DevicesApi.md#put_device) | **PUT** /devices | PUT device
*DevicesApi* | [**put_device_status**](docs/DevicesApi.md#put_device_status) | **PUT** /devices/{device_id}/status | PUT device status
*DevicesApi* | [**put_host_config**](docs/DevicesApi.md#put_host_config) | **PUT** /host/config | 
*RequestsApi* | [**dect_get_last_commands**](docs/RequestsApi.md#dect_get_last_commands) | **GET** /requests/{device_id}/DECT_get_last_commands | DECT Get Last Commands
*RequestsApi* | [**delete_appium_all_screenshots**](docs/RequestsApi.md#delete_appium_all_screenshots) | **DELETE** /requests/{controller_id}/APPIUM_delete_all_screenshots | DELETE APPIUM all screenshots
*RequestsApi* | [**delete_appium_ios_certificates**](docs/RequestsApi.md#delete_appium_ios_certificates) | **DELETE** /requests/{controller_id}/APPIUM_delete_ios_certificates | DELETE APPIUM audio playback file
*RequestsApi* | [**delete_audio_playback_file**](docs/RequestsApi.md#delete_audio_playback_file) | **DELETE** /requests/{controller_id}/delete_audio_playback_file | DELETE audio playback file
*RequestsApi* | [**delete_request**](docs/RequestsApi.md#delete_request) | **DELETE** /requests | DELETE request
*RequestsApi* | [**delete_result_file**](docs/RequestsApi.md#delete_result_file) | **DELETE** /requests/{request_id}/delete_result_file | DELETE result file
*RequestsApi* | [**delete_result_files_in_range**](docs/RequestsApi.md#delete_result_files_in_range) | **DELETE** /requests/{controller_id}/delete_result_files_in_range | DELETE result files in date-time range
*RequestsApi* | [**get_appium_device_screenshot_list**](docs/RequestsApi.md#get_appium_device_screenshot_list) | **GET** /requests/{controller_id}/APPIUM_get_screenshot_list | GET APPIUM device screenshot list
*RequestsApi* | [**get_appium_retrieve_device_screenshot**](docs/RequestsApi.md#get_appium_retrieve_device_screenshot) | **GET** /requests/{request_id}/APPIUM_retrieve_screenshot | GET APPIUM retrieve screenshot
*RequestsApi* | [**get_audio_playback_file_list**](docs/RequestsApi.md#get_audio_playback_file_list) | **GET** /requests/{controller_id}/get_audio_playback_file_list | GET audio playback file list
*RequestsApi* | [**get_requests**](docs/RequestsApi.md#get_requests) | **GET** /requests | GET requests
*RequestsApi* | [**get_retrieve_test_result_file**](docs/RequestsApi.md#get_retrieve_test_result_file) | **GET** /requests/{request_id}/retrieve_result_file | GET test result file
*RequestsApi* | [**get_test_result_file_list**](docs/RequestsApi.md#get_test_result_file_list) | **GET** /requests/{controller_id}/get_result_file_list | GET test result file list
*RequestsApi* | [**post_request_heartbeat**](docs/RequestsApi.md#post_request_heartbeat) | **POST** /requests/{request_id}/heartbeat | POST request heartbeat
*RequestsApi* | [**put_appium_install_ios_webdriveragent**](docs/RequestsApi.md#put_appium_install_ios_webdriveragent) | **PUT** /requests/{controller_id}/APPIUM_install_ios_webdriveragent | PUT APPIUM install ios webdriveragent
*RequestsApi* | [**put_appium_upload_ios_certificates**](docs/RequestsApi.md#put_appium_upload_ios_certificates) | **PUT** /requests/{controller_id}/APPIUM_upload_ios_certificates | PUT APPIUM upload ios certificates
*RequestsApi* | [**put_request**](docs/RequestsApi.md#put_request) | **PUT** /requests | PUT request
*RequestsApi* | [**put_request_status**](docs/RequestsApi.md#put_request_status) | **PUT** /requests/{request_id}/status | PUT request status
*RequestsApi* | [**put_upload_audio_playback_file**](docs/RequestsApi.md#put_upload_audio_playback_file) | **PUT** /requests/{controller_id}/upload_audio_playback_file | PUT upload audio playback file


## Documentation For Models

 - [Controller](docs/Controller.md)
 - [Device](docs/Device.md)
 - [GetTestResultFileList200Response](docs/GetTestResultFileList200Response.md)
 - [GetTestResultFileList200ResponseFilesInner](docs/GetTestResultFileList200ResponseFilesInner.md)
 - [HostConfig](docs/HostConfig.md)
 - [PostDeviceRegisterRequest](docs/PostDeviceRegisterRequest.md)
 - [Request](docs/Request.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author

shaun.hirst@3adesign.co.uk


